/**
 * Copyright (c) 2001 by Timothy W Macinta                <br>
 * http://www.twmacinta.com/                              <br>
 * http://www.twmacinta.com/myjava/ucon_timeout.php       <br>
 * <p>
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * <p>
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * <p>
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Tim Macinta (twm@alum.mit.edu)
 **/

#include <jni.h>
#include "URLConnectionUtils.h"

JNIEXPORT void JNICALL Java_com_twmacinta_net_URLConnectionUtils__1clobberHTTPUConInternals (JNIEnv *env, jclass cls, jobject ucon) {
  jclass ucon_cls, http_cls;
  jfieldID http_fid, failedOnce_fid, connected_fid, doInput_fid, doOutput_fid;
  jobject http;
  jmethodID closeServer;

  ucon_cls = (*env)->GetObjectClass(env, ucon);
  http_fid = (*env)->GetFieldID(env, ucon_cls, "http", "Lsun/net/www/http/HttpClient;");
  http = (*env)->GetObjectField(env, ucon, http_fid);

  if ((*env)->ExceptionOccurred(env)) {
    (*env)->ExceptionClear(env);
  } else {
    if (http != NULL) {
      http_cls = (*env)->GetObjectClass(env, http);
      failedOnce_fid = (*env)->GetFieldID(env, http_cls, "failedOnce", "Z");
      (*env)->SetBooleanField(env, http, failedOnce_fid, JNI_TRUE);
    }
  }
  
  doInput_fid = (*env)->GetFieldID(env, ucon_cls, "doInput", "Z");
  (*env)->SetBooleanField(env, ucon, doInput_fid, JNI_FALSE);
  
  doOutput_fid = (*env)->GetFieldID(env, ucon_cls, "doOutput", "Z");
  (*env)->SetBooleanField(env, ucon, doOutput_fid, JNI_FALSE);

  return;
}
